Index: bus_space.9
===================================================================
RCS file: /cvsroot/sharesrc/share/man/man9/bus_space.9,v
retrieving revision 1.27
diff -u -r1.27 bus_space.9
--- bus_space.9	2002/10/09 19:18:44	1.27
+++ bus_space.9	2002/10/13 21:51:37
@@ -1,5 +1,7 @@
-.\" $NetBSD: bus_space.9,v 1.27 2002/10/09 19:18:44 wiz Exp $
+.\" $NetBSD: bus_space.9,v 1.26 2002/09/25 22:59:40 heinz Exp $
+.\" $FreeBSD$
 .\"
+.\" Copyright (c) 2002 Hiten Mahesh Pandya (hiten@uk.FreeBSD.org)
 .\" Copyright (c) 1997 The NetBSD Foundation, Inc.
 .\" All rights reserved.
 .\"
@@ -46,14 +48,6 @@
 .Nm bus_space_copy_region_8 ,
 .Nm bus_space_free ,
 .Nm bus_space_map ,
-.Nm bus_space_peek_1 ,
-.Nm bus_space_peek_2 ,
-.Nm bus_space_peek_4 ,
-.Nm bus_space_peek_8 ,
-.Nm bus_space_poke_1 ,
-.Nm bus_space_poke_2 ,
-.Nm bus_space_poke_4 ,
-.Nm bus_space_poke_8 ,
 .Nm bus_space_read_1 ,
 .Nm bus_space_read_2 ,
 .Nm bus_space_read_4 ,
@@ -109,248 +103,223 @@
 .Nm bus_space_write_stream_1 ,
 .Nm bus_space_write_stream_2 ,
 .Nm bus_space_write_stream_4 ,
-.Nm bus_space_write_stream_8
+.Nm bus_space_write_stream_8 ,
 .Nd bus space manipulation functions
 .Sh SYNOPSIS
-.Fd #include \*[Lt]machine/bus.h\*[Gt]
+.In machine/bus.h
 .Ft int
-.Fn bus_space_map "bus_space_tag_t space" "bus_addr_t address" \
-"bus_size_t size" "int flags" "bus_space_handle_t *handlep"
+.Fn bus_space_map "bus_space_tag_t t" "bus_addr_t addr" \
+"bus_size_t size" "int flags" "bus_space_handle_t *bshp"
 .Ft void
-.Fn bus_space_unmap "bus_space_tag_t space" "bus_space_handle_t handle" \
+.Fn bus_space_unmap "bus_space_tag_t t" "bus_space_handle_t bsh" \
 "bus_size_t size"
 .Ft int
-.Fn bus_space_subregion "bus_space_tag_t space" "bus_space_handle_t handle" \
-"bus_size_t offset" "bus_size_t size" "bus_space_handle_t *nhandlep"
+.Fn bus_space_subregion "bus_space_tag_t t" "bus_space_handle_t bsh" \
+"bus_size_t offset" "bus_size_t size" "bus_space_handle_t *nbshp"
 .Ft int
-.Fo bus_space_alloc
-.Fa "bus_space_tag_t space" "bus_addr_t reg_start" "bus_addr_t reg_end"
-.Fa "bus_size_t size" "bus_size_t alignment" "bus_size_t boundary"
-.Fa "int flags" "bus_addr_t *addrp" "bus_space_handle_t *handlep"
-.Fc
+.Fn bus_space_alloc "bus_space_tag_t t" "bus_addr_t rstart" \
+"bus_addr_t rend" "bus_size_t size" "bus_size_t align" \
+"bus_size_t boundary" "int flags" "bus_addr_t *addrp" \
+"bus_space_handle_t *bshp"
 .Ft void
-.Fn bus_space_free "bus_space_tag_t space" "bus_space_handle_t handle" \
+.Fn bus_space_free "bus_space_tag_t t" "bus_space_handle_t bsh" \
 "bus_size_t size"
 .Ft void *
-.Fn bus_space_vaddr "bus_space_tag_t space" "bus_space_handle_t handle"
+.Fn bus_space_vaddr "bus_space_tag_t t" "bus_space_handle_t bsh"
 .Ft paddr_t
-.Fn bus_space_mmap "bus_space_tag_t space" "bus_addr_t addr" "off_t off" \
+.Fn bus_space_mmap "bus_space_tag_t t" "bus_addr_t addr" "off_t off" \
 "int prot" "int flags"
-.Ft int
-.Fn bus_space_peek_1 "bus_space_tag_t space" "bus_space_handle_t handle" \
-"bus_size_t offset" "u_int8_t *datap"
-.Ft int
-.Fn bus_space_peek_2 "bus_space_tag_t space" "bus_space_handle_t handle" \
-"bus_size_t offset" "u_int16_t *datap"
-.Ft int
-.Fn bus_space_peek_4 "bus_space_tag_t space" "bus_space_handle_t handle" \
-"bus_size_t offset" "u_int32_t *datap"
-.Ft int
-.Fn bus_space_peek_8 "bus_space_tag_t space" "bus_space_handle_t handle" \
-"bus_size_t offset" "u_int64_t *datap"
-.Ft int
-.Fn bus_space_poke_1 "bus_space_tag_t space" "bus_space_handle_t handle" \
-"bus_size_t offset" "u_int8_t data"
-.Ft int
-.Fn bus_space_poke_2 "bus_space_tag_t space" "bus_space_handle_t handle" \
-"bus_size_t offset" "u_int16_t data"
-.Ft int
-.Fn bus_space_poke_4 "bus_space_tag_t space" "bus_space_handle_t handle" \
-"bus_size_t offset" "u_int32_t data"
-.Ft int
-.Fn bus_space_poke_8 "bus_space_tag_t space" "bus_space_handle_t handle" \
-"bus_size_t offset" "u_int64_t data"
 .Ft u_int8_t
-.Fn bus_space_read_1 "bus_space_tag_t space" "bus_space_handle_t handle" \
+.Fn bus_space_read_1 "bus_space_tag_t t" "bus_space_handle_t handle" \
 "bus_size_t offset"
 .Ft u_int16_t
-.Fn bus_space_read_2 "bus_space_tag_t space" "bus_space_handle_t handle" \
+.Fn bus_space_read_2 "bus_space_tag_t t" "bus_space_handle_t handle" \
 "bus_size_t offset"
 .Ft u_int32_t
-.Fn bus_space_read_4 "bus_space_tag_t space" "bus_space_handle_t handle" \
+.Fn bus_space_read_4 "bus_space_tag_t t" "bus_space_handle_t handle" \
 "bus_size_t offset"
 .Ft u_int64_t
-.Fn bus_space_read_8 "bus_space_tag_t space" "bus_space_handle_t handle" \
+.Fn bus_space_read_8 "bus_space_tag_t t" "bus_space_handle_t handle" \
 "bus_size_t offset"
 .Ft void
-.Fn bus_space_write_1 "bus_space_tag_t space" "bus_space_handle_t handle" \
+.Fn bus_space_write_1 "bus_space_tag_t tag" "bus_space_handle_t bsh" \
 "bus_size_t offset" "u_int8_t value"
 .Ft void
-.Fn bus_space_write_2 "bus_space_tag_t space" "bus_space_handle_t handle" \
+.Fn bus_space_write_2 "bus_space_tag_t tag" "bus_space_handle_t bsh" \
 "bus_size_t offset" "u_int16_t value"
 .Ft void
-.Fn bus_space_write_4 "bus_space_tag_t space" "bus_space_handle_t handle" \
+.Fn bus_space_write_4 "bus_space_tag_t tag" "bus_space_handle_t bsh" \
 "bus_size_t offset" "u_int32_t value"
 .Ft void
-.Fn bus_space_write_8 "bus_space_tag_t space" "bus_space_handle_t handle" \
+.Fn bus_space_write_8 "bus_space_tag_t tag" "bus_space_handle_t bsh" \
 "bus_size_t offset" "u_int64_t value"
 .Ft void
-.Fn bus_space_barrier "bus_space_tag_t space" "bus_space_handle_t handle" \
-"bus_size_t offset" "bus_size_t length" "int flags"
+.Fn bus_space_barrier "bus_space_tag_t tag" "bus_space_handle_t bsh" \
+"bus_size_t offset" "bus_size_t len" "int flags"
 .Ft void
-.Fn bus_space_read_region_1 "bus_space_tag_t space" \
-"bus_space_handle_t handle" "bus_size_t offset" "u_int8_t *datap" \
-"bus_size_t count"
+.Fn bus_space_read_region_1 "bus_space_tag_t tag" \
+"bus_space_handle_t bsh" "bus_size_t offset" "u_int8_t *addr" \
+"size_t count"
 .Ft void
-.Fn bus_space_read_region_2 "bus_space_tag_t space" \
-"bus_space_handle_t handle" "bus_size_t offset" "u_int16_t *datap" \
-"bus_size_t count"
+.Fn bus_space_read_region_2 "bus_space_tag_t tag" \
+"bus_space_handle_t bsh" "bus_size_t offset" "u_int16_t *addr" \
+"size_t count"
 .Ft void
-.Fn bus_space_read_region_4 "bus_space_tag_t space" \
-"bus_space_handle_t handle" "bus_size_t offset" "u_int32_t *datap" \
-"bus_size_t count"
+.Fn bus_space_read_region_4 "bus_space_tag_t tag" \
+"bus_space_handle_t bsh" "bus_size_t offset" "u_int32_t *addr" \
+"size_t count"
 .Ft void
-.Fn bus_space_read_region_8 "bus_space_tag_t space" \
-"bus_space_handle_t handle" "bus_size_t offset" "u_int64_t *datap" \
-"bus_size_t count"
+.Fn bus_space_read_region_8 "bus_space_tag_t tag" \
+"bus_space_handle_t bsh" "bus_size_t offset" "u_int64_t *addr" \
+"size_t count"
 .Ft void
-.Fn bus_space_read_region_stream_1 "bus_space_tag_t space" \
-"bus_space_handle_t handle" "bus_size_t offset" "u_int8_t *datap" \
-"bus_size_t count"
+.Fn bus_space_read_region_stream_1 "bus_space_tag_t tag" \
+"bus_space_handle_t bsh" "bus_size_t offset" "u_int8_t *addr" \
+"size_t count"
 .Ft void
-.Fn bus_space_read_region_stream_2 "bus_space_tag_t space" \
-"bus_space_handle_t handle" "bus_size_t offset" "u_int16_t *datap" \
-"bus_size_t count"
+.Fn bus_space_read_region_stream_2 "bus_space_tag_t tag" \
+"bus_space_handle_t bsh" "bus_size_t offset" "u_int16_t *addr" \
+"size_t count"
 .Ft void
-.Fn bus_space_read_region_stream_4 "bus_space_tag_t space" \
-"bus_space_handle_t handle" "bus_size_t offset" "u_int32_t *datap" \
-"bus_size_t count"
+.Fn bus_space_read_region_stream_4 "bus_space_tag_t tag" \
+"bus_space_handle_t bsh" "bus_size_t offset" "u_int32_t *addr" \
+"size_t count"
 .Ft void
-.Fn bus_space_read_region_stream_8 "bus_space_tag_t space" \
-"bus_space_handle_t handle" "bus_size_t offset" "u_int64_t *datap" \
-"bus_size_t count"
+.Fn bus_space_read_region_stream_8 "bus_space_tag_t tag" \
+"bus_space_handle_t bsh" "bus_size_t offset" "u_int64_t *addr" \
+"size_t count"
 .Ft void
-.Fn bus_space_write_region_1 "bus_space_tag_t space" \
-"bus_space_handle_t handle" "bus_size_t offset" "const u_int8_t *datap" \
-"bus_size_t count"
+.Fn bus_space_write_region_1 "bus_space_tag_t tag" \
+"bus_space_handle_t bsh" "bus_size_t offset" "const u_int8_t *addr" \
+"size_t count"
 .Ft void
-.Fn bus_space_write_region_2 "bus_space_tag_t space" \
-"bus_space_handle_t handle" "bus_size_t offset" "const u_int16_t *datap" \
-"bus_size_t count"
+.Fn bus_space_write_region_2 "bus_space_tag_t t" \
+"bus_space_handle_t bsh" "bus_size_t offset" "const u_int16_t *addr" \
+"size_t count"
 .Ft void
-.Fn bus_space_write_region_4 "bus_space_tag_t space" \
-"bus_space_handle_t handle" "bus_size_t offset" "const u_int32_t *datap" \
-"bus_size_t count"
+.Fn bus_space_write_region_4 "bus_space_tag_t t" \
+"bus_space_handle_t bsh" "bus_size_t offset" "const u_int32_t *addr" \
+"size_t count"
 .Ft void
-.Fn bus_space_write_region_8 "bus_space_tag_t space" \
-"bus_space_handle_t handle" "bus_size_t offset" "const u_int64_t *datap" \
-"bus_size_t count"
+.Fn bus_space_write_region_8 "bus_space_tag_t t" \
+"bus_space_handle_t bsh" "bus_size_t offset" "const u_int64_t *addr" \
+"size_t count"
 .Ft void
-.Fn bus_space_write_region_stream_1 "bus_space_tag_t space" \
-"bus_space_handle_t handle" "bus_size_t offset" "const u_int8_t *datap" \
-"bus_size_t count"
+.Fn bus_space_write_region_stream_1 "bus_space_tag_t tag" \
+"bus_space_handle_t bsh" "bus_size_t offset" "const u_int8_t *addr" \
+"size_t count"
 .Ft void
-.Fn bus_space_write_region_stream_2 "bus_space_tag_t space" \
-"bus_space_handle_t handle" "bus_size_t offset" "const u_int16_t *datap" \
-"bus_size_t count"
+.Fn bus_space_write_region_stream_2 "bus_space_tag_t tag" \
+"bus_space_handle_t bsh" "bus_size_t offset" "const u_int16_t *addr" \
+"size_t count"
 .Ft void
-.Fn bus_space_write_region_stream_4 "bus_space_tag_t space" \
-"bus_space_handle_t handle" "bus_size_t offset" "const u_int32_t *datap" \
-"bus_size_t count"
+.Fn bus_space_write_region_stream_4 "bus_space_tag_t tag" \
+"bus_space_handle_t bsh" "bus_size_t offset" "const u_int32_t *addr" \
+"size_t count"
 .Ft void
-.Fn bus_space_write_region_stream_8 "bus_space_tag_t space" \
-"bus_space_handle_t handle" "bus_size_t offset" "const u_int64_t *datap" \
-"bus_size_t count"
+.Fn bus_space_write_region_stream_8 "bus_space_tag_t tag" \
+"bus_space_handle_t bsh" "bus_size_t offset" "const u_int64_t *addr" \
+"size_t count"
 .Ft void
-.Fn bus_space_copy_region_1 "bus_space_tag_t space" \
-"bus_space_handle_t srchandle" "bus_size_t srcoffset" \
-"bus_space_handle_t dsthandle" "bus_size_t dstoffset" "bus_size_t count"
-.Ft void
-.Fn bus_space_copy_region_2 "bus_space_tag_t space" \
-"bus_space_handle_t srchandle" "bus_size_t srcoffset" \
-"bus_space_handle_t dsthandle" "bus_size_t dstoffset" "bus_size_t count"
-.Ft void
-.Fn bus_space_copy_region_4 "bus_space_tag_t space" \
-"bus_space_handle_t srchandle" "bus_size_t srcoffset" \
-"bus_space_handle_t dsthandle" "bus_size_t dstoffset" "bus_size_t count"
-.Ft void
-.Fn bus_space_copy_region_8 "bus_space_tag_t space" \
-"bus_space_handle_t srchandle" "bus_size_t srcoffset" \
-"bus_space_handle_t dsthandle" "bus_size_t dstoffset" "bus_size_t count"
+.Fn bus_space_copy_region_1 "bus_space_tag_t tag" \
+"bus_space_handle_t bsh1" "bus_size_t off1" \
+"bus_space_handle_t bsh2" "bus_size_t off2" "size_t count"
 .Ft void
-.Fn bus_space_set_region_1 "bus_space_tag_t space" \
-"bus_space_handle_t handle" "bus_size_t offset" "u_int8_t value" \
-"bus_size_t count"
+.Fn bus_space_copy_region_2 "bus_space_tag_t tag" \
+"bus_space_handle_t bsh1" "bus_size_t off1" \
+"bus_space_handle_t bsh2" "bus_size_t off2" "size_t count"
 .Ft void
-.Fn bus_space_set_region_2 "bus_space_tag_t space" \
-"bus_space_handle_t handle" "bus_size_t offset" "u_int16_t value" \
-"bus_size_t count"
+.Fn bus_space_copy_region_4 "bus_space_tag_t tag" \
+"bus_space_handle_t bsh1" "bus_size_t off1" \
+"bus_space_handle_t bsh2" "bus_size_t off2" "bus_size_t count"
 .Ft void
-.Fn bus_space_set_region_4 "bus_space_tag_t space" \
-"bus_space_handle_t handle" "bus_size_t offset" "u_int32_t value" \
-"bus_size_t count"
+.Fn bus_space_copy_region_8 "bus_space_tag_t tag" \
+"bus_space_handle_t bsh1" "bus_size_t off1" \
+"bus_space_handle_t bsh2" "bus_size_t off2" "bus_size_t count"
 .Ft void
-.Fn bus_space_set_region_8 "bus_space_tag_t space" \
-"bus_space_handle_t handle" "bus_size_t offset" "u_int64_t value" \
-"bus_size_t count"
+.Fn bus_space_set_region_1 "bus_space_tag_t tag" \
+"bus_space_handle_t bsh" "bus_size_t offset" "u_int8_t value" \
+"size_t count"
 .Ft void
-.Fn bus_space_read_multi_1 "bus_space_tag_t space" \
-"bus_space_handle_t handle" "bus_size_t offset" "u_int8_t *datap" \
+.Fn bus_space_set_region_2 "bus_space_tag_t tag" \
+"bus_space_handle_t bsh" "bus_size_t offset" "u_int16_t value" \
+"size_t count"
+.Ft void
+.Fn bus_space_set_region_4 "bus_space_tag_t tag" \
+"bus_space_handle_t bsh" "bus_size_t offset" "u_int32_t value" \
+"size_t count"
+.Ft void
+.Fn bus_space_set_region_8 "bus_space_tag_t tag" \
+"bus_space_handle_t bsh" "bus_size_t offset" "u_int64_t value" \
+"size_t count"
+.Ft void
+.Fn bus_space_read_multi_1 "bus_space_tag_t t" \
+"bus_space_handle_t handle" "bus_size_t offset" "u_int8_t *addr" \
 "bus_size_t count"
 .Ft void
-.Fn bus_space_read_multi_2 "bus_space_tag_t space" \
-"bus_space_handle_t handle" "bus_size_t offset" "u_int16_t *datap" \
+.Fn bus_space_read_multi_2 "bus_space_tag_t t" \
+"bus_space_handle_t handle" "bus_size_t offset" "u_int16_t *addr" \
 "bus_size_t count"
 .Ft void
-.Fn bus_space_read_multi_4 "bus_space_tag_t space" \
-"bus_space_handle_t handle" "bus_size_t offset" "u_int32_t *datap" \
+.Fn bus_space_read_multi_4 "bus_space_tag_t t" \
+"bus_space_handle_t handle" "bus_size_t offset" "u_int32_t *addr" \
 "bus_size_t count"
 .Ft void
-.Fn bus_space_read_multi_8 "bus_space_tag_t space" \
-"bus_space_handle_t handle" "bus_size_t offset" "u_int64_t *datap" \
+.Fn bus_space_read_multi_8 "bus_space_tag_t t" \
+"bus_space_handle_t handle" "bus_size_t offset" "u_int64_t *addr" \
 "bus_size_t count"
 .Ft void
-.Fn bus_space_read_multi_stream_1 "bus_space_tag_t space" \
-"bus_space_handle_t handle" "bus_size_t offset" "u_int8_t *datap" \
+.Fn bus_space_read_multi_stream_1 "bus_space_tag_t t" \
+"bus_space_handle_t handle" "bus_size_t offset" "u_int8_t *addr" \
 "bus_size_t count"
 .Ft void
-.Fn bus_space_read_multi_stream_2 "bus_space_tag_t space" \
-"bus_space_handle_t handle" "bus_size_t offset" "u_int16_t *datap" \
+.Fn bus_space_read_multi_stream_2 "bus_space_tag_t t" \
+"bus_space_handle_t handle" "bus_size_t offset" "u_int16_t *addr" \
 "bus_size_t count"
 .Ft void
-.Fn bus_space_read_multi_stream_4 "bus_space_tag_t space" \
-"bus_space_handle_t handle" "bus_size_t offset" "u_int32_t *datap" \
+.Fn bus_space_read_multi_stream_4 "bus_space_tag_t t" \
+"bus_space_handle_t handle" "bus_size_t offset" "u_int32_t *addr" \
 "bus_size_t count"
 .Ft void
-.Fn bus_space_read_multi_stream_8 "bus_space_tag_t space" \
-"bus_space_handle_t handle" "bus_size_t offset" "u_int64_t *datap" \
+.Fn bus_space_read_multi_stream_8 "bus_space_tag_t t" \
+"bus_space_handle_t handle" "bus_size_t offset" "u_int64_t *addr" \
 "bus_size_t count"
 .Ft void
-.Fn bus_space_write_multi_1 "bus_space_tag_t space" \
-"bus_space_handle_t handle" "bus_size_t offset" "const u_int8_t *datap" \
+.Fn bus_space_write_multi_1 "bus_space_tag_t t" \
+"bus_space_handle_t handle" "bus_size_t offset" "const u_int8_t *addr" \
 "bus_size_t count"
 .Ft void
-.Fn bus_space_write_multi_2 "bus_space_tag_t space" \
-"bus_space_handle_t handle" "bus_size_t offset" "const u_int16_t *datap" \
+.Fn bus_space_write_multi_2 "bus_space_tag_t t" \
+"bus_space_handle_t handle" "bus_size_t offset" "const u_int16_t *addr" \
 "bus_size_t count"
 .Ft void
-.Fn bus_space_write_multi_4 "bus_space_tag_t space" \
-"bus_space_handle_t handle" "bus_size_t offset" "const u_int32_t *datap" \
+.Fn bus_space_write_multi_4 "bus_space_tag_t t" \
+"bus_space_handle_t handle" "bus_size_t offset" "const u_int32_t *addr" \
 "bus_size_t count"
 .Ft void
-.Fn bus_space_write_multi_8 "bus_space_tag_t space" \
-"bus_space_handle_t handle" "bus_size_t offset" "const u_int64_t *datap" \
+.Fn bus_space_write_multi_8 "bus_space_tag_t t" \
+"bus_space_handle_t handle" "bus_size_t offset" "const u_int64_t *addr" \
 "bus_size_t count"
 .Ft void
-.Fn bus_space_write_multi_stream_1 "bus_space_tag_t space" \
-"bus_space_handle_t handle" "bus_size_t offset" "const u_int8_t *datap" \
+.Fn bus_space_write_multi_stream_1 "bus_space_tag_t t" \
+"bus_space_handle_t handle" "bus_size_t offset" "const u_int8_t *addr" \
 "bus_size_t count"
 .Ft void
-.Fn bus_space_write_multi_stream_2 "bus_space_tag_t space" \
-"bus_space_handle_t handle" "bus_size_t offset" "const u_int16_t *datap" \
+.Fn bus_space_write_multi_stream_2 "bus_space_tag_t t" \
+"bus_space_handle_t handle" "bus_size_t offset" "const u_int16_t *addr" \
 "bus_size_t count"
 .Ft void
-.Fn bus_space_write_multi_stream_4 "bus_space_tag_t space" \
-"bus_space_handle_t handle" "bus_size_t offset" "const u_int32_t *datap" \
+.Fn bus_space_write_multi_stream_4 "bus_space_tag_t t" \
+"bus_space_handle_t handle" "bus_size_t offset" "const u_int32_t *addr" \
 "bus_size_t count"
 .Ft void
-.Fn bus_space_write_multi_stream_8 "bus_space_tag_t space" \
-"bus_space_handle_t handle" "bus_size_t offset" "const u_int64_t *datap" \
+.Fn bus_space_write_multi_stream_8 "bus_space_tag_t t" \
+"bus_space_handle_t handle" "bus_size_t offset" "const u_int64_t *addr" \
 "bus_size_t count"
 .Sh DESCRIPTION
 The
 .Nm
-functions exist to allow device drivers
+interface exists to allow device drivers
 machine-independent access to bus memory and register areas.  All of the
 functions and types described in this document can be used by including
 the
@@ -387,6 +356,15 @@
 to avoid confusion with the
 machine-independent types and functions, and, if possible, should be
 given names which make the machine-dependence clear.
+.Pp
+Some of the
+.Nm
+functions are not available on every platform, due to architectural
+constraints, e.g. the 64bit (8byte) routines (bus_space_xxx_8) are
+not available on the Intel 386 architecture, because there is no
+architetural support for 8byte transfers.
+This means, that drivers written to use this functionality cannot
+function on FreeBSD platforms which have not implmented the interface.
 .Sh CONCEPTS AND GUIDELINES
 Bus spaces are described by bus space tags, which can be created only by
 machine-dependent code.  A given machine may have several different types
@@ -1003,10 +981,10 @@
 This constraint may be removed at some point in the future.
 .Pp
 .Bl -ohang -compact
-.It Fn bus_space_peek_1 "space" "handle" "offset" "datap"
-.It Fn bus_space_peek_2 "space" "handle" "offset" "datap"
-.It Fn bus_space_peek_4 "space" "handle" "offset" "datap"
-.It Fn bus_space_peek_8 "space" "handle" "offset" "datap"
+.It Fn bus_space_peek_1 "space" "handle" "offset" "addr"
+.It Fn bus_space_peek_2 "space" "handle" "offset" "addr"
+.It Fn bus_space_peek_4 "space" "handle" "offset" "addr"
+.It Fn bus_space_peek_8 "space" "handle" "offset" "addr"
 .Pp
 The
 .Fn bus_space_peek_N
@@ -1018,9 +996,9 @@
 of the bus space specified by
 .Fa space .
 The data item read is stored in the location pointed to by
-.Fa datap .
+.Fa addr .
 It is permissible for
-.Fa datap
+.Fa addr
 to be NULL, in which case the data item will be discarded after being read.
 .Pp
 .It Fn bus_space_poke_1 "space" "handle" "offset" "value"
@@ -1163,10 +1141,10 @@
 family of functions allow drivers to perform these operations.
 .Pp
 .Bl -ohang -compact
-.It Fn bus_space_read_region_1 "space" "handle" "offset" "datap" "count"
-.It Fn bus_space_read_region_2 "space" "handle" "offset" "datap" "count"
-.It Fn bus_space_read_region_4 "space" "handle" "offset" "datap" "count"
-.It Fn bus_space_read_region_8 "space" "handle" "offset" "datap" "count"
+.It Fn bus_space_read_region_1 "space" "handle" "offset" "addr" "count"
+.It Fn bus_space_read_region_2 "space" "handle" "offset" "addr" "count"
+.It Fn bus_space_read_region_4 "space" "handle" "offset" "addr" "count"
+.It Fn bus_space_read_region_8 "space" "handle" "offset" "addr" "count"
 .Pp
 The
 .Fn bus_space_read_region_N
@@ -1180,7 +1158,7 @@
 of the bus space specified by
 .Fa space
 and writes them into the array specified by
-.Fa datap .
+.Fa addr .
 Each successive data item is read from an offset
 1, 2, 4, or 8 bytes after the previous data item (depending on which
 function is used).  All locations being read must lie within the bus
@@ -1209,10 +1187,10 @@
 argument error), that indicates a software bug which should cause a
 panic.  In that case, they will never return.
 .Pp
-.It Fn bus_space_write_region_1 "space" "handle" "offset" "datap" "count"
-.It Fn bus_space_write_region_2 "space" "handle" "offset" "datap" "count"
-.It Fn bus_space_write_region_4 "space" "handle" "offset" "datap" "count"
-.It Fn bus_space_write_region_8 "space" "handle" "offset" "datap" "count"
+.It Fn bus_space_write_region_1 "space" "handle" "offset" "addr" "count"
+.It Fn bus_space_write_region_2 "space" "handle" "offset" "addr" "count"
+.It Fn bus_space_write_region_4 "space" "handle" "offset" "addr" "count"
+.It Fn bus_space_write_region_8 "space" "handle" "offset" "addr" "count"
 .Pp
 The
 .Fn bus_space_write_region_N
@@ -1220,7 +1198,7 @@
 .Fa count
 1, 2, 4, or 8 byte data items from the array
 specified by
-.Fa datap
+.Fa addr
 and writes them to bus space starting at byte offset
 .Fa offset
 in the region specified by
@@ -1369,10 +1347,10 @@
 families of functions are provided.
 .Pp
 .Bl -ohang -compact
-.It Fn bus_space_read_multi_1 "space" "handle" "offset" "datap" "count"
-.It Fn bus_space_read_multi_2 "space" "handle" "offset" "datap" "count"
-.It Fn bus_space_read_multi_4 "space" "handle" "offset" "datap" "count"
-.It Fn bus_space_read_multi_8 "space" "handle" "offset" "datap" "count"
+.It Fn bus_space_read_multi_1 "space" "handle" "offset" "addr" "count"
+.It Fn bus_space_read_multi_2 "space" "handle" "offset" "addr" "count"
+.It Fn bus_space_read_multi_4 "space" "handle" "offset" "addr" "count"
+.It Fn bus_space_read_multi_8 "space" "handle" "offset" "addr" "count"
 .Pp
 The
 .Fn bus_space_read_multi_N
@@ -1386,7 +1364,7 @@
 of the bus space specified by
 .Fa space
 and writes them into the array specified by
-.Fa datap .
+.Fa addr .
 Each successive data item is read from the same location in bus
 space.  The location being read must lie within the bus space region
 specified by
@@ -1415,10 +1393,10 @@
 argument error), that indicates a software bug which should cause a
 panic.  In that case, they will never return.
 .Pp
-.It Fn bus_space_write_multi_1 "space" "handle" "offset" "datap" "count"
-.It Fn bus_space_write_multi_2 "space" "handle" "offset" "datap" "count"
-.It Fn bus_space_write_multi_4 "space" "handle" "offset" "datap" "count"
-.It Fn bus_space_write_multi_8 "space" "handle" "offset" "datap" "count"
+.It Fn bus_space_write_multi_1 "space" "handle" "offset" "addr" "count"
+.It Fn bus_space_write_multi_2 "space" "handle" "offset" "addr" "count"
+.It Fn bus_space_write_multi_4 "space" "handle" "offset" "addr" "count"
+.It Fn bus_space_write_multi_8 "space" "handle" "offset" "addr" "count"
 .Pp
 The
 .Fn bus_space_write_multi_N
@@ -1426,7 +1404,7 @@
 .Fa count
 1, 2, 4, or 8 byte data items from the array
 specified by
-.Fa datap
+.Fa addr
 and writes them into bus space at byte offset
 .Fa offset
 in the region specified by
@@ -1476,26 +1454,26 @@
 .It Fn bus_space_read_stream_2 "space" "handle" "offset"
 .It Fn bus_space_read_stream_4 "space" "handle" "offset"
 .It Fn bus_space_read_stream_8 "space" "handle" "offset"
-.It Fn bus_space_read_multi_stream_1 "space" "handle" "offset" "datap" "count"
-.It Fn bus_space_read_multi_stream_2 "space" "handle" "offset" "datap" "count"
-.It Fn bus_space_read_multi_stream_4 "space" "handle" "offset" "datap" "count"
-.It Fn bus_space_read_multi_stream_8 "space" "handle" "offset" "datap" "count"
-.It Fn bus_space_read_region_stream_1 "space" "handle" "offset" "datap" "count"
-.It Fn bus_space_read_region_stream_2 "space" "handle" "offset" "datap" "count"
-.It Fn bus_space_read_region_stream_4 "space" "handle" "offset" "datap" "count"
-.It Fn bus_space_read_region_stream_8 "space" "handle" "offset" "datap" "count"
+.It Fn bus_space_read_multi_stream_1 "space" "handle" "offset" "addr" "count"
+.It Fn bus_space_read_multi_stream_2 "space" "handle" "offset" "addr" "count"
+.It Fn bus_space_read_multi_stream_4 "space" "handle" "offset" "addr" "count"
+.It Fn bus_space_read_multi_stream_8 "space" "handle" "offset" "addr" "count"
+.It Fn bus_space_read_region_stream_1 "space" "handle" "offset" "addr" "count"
+.It Fn bus_space_read_region_stream_2 "space" "handle" "offset" "addr" "count"
+.It Fn bus_space_read_region_stream_4 "space" "handle" "offset" "addr" "count"
+.It Fn bus_space_read_region_stream_8 "space" "handle" "offset" "addr" "count"
 .It Fn bus_space_write_stream_1 "space" "handle" "offset" "value"
 .It Fn bus_space_write_stream_2 "space" "handle" "offset" "value"
 .It Fn bus_space_write_stream_4 "space" "handle" "offset" "value"
 .It Fn bus_space_write_stream_8 "space" "handle" "offset" "value"
-.It Fn bus_space_write_multi_stream_1 "space" "handle" "offset" "datap" "count"
-.It Fn bus_space_write_multi_stream_2 "space" "handle" "offset" "datap" "count"
-.It Fn bus_space_write_multi_stream_4 "space" "handle" "offset" "datap" "count"
-.It Fn bus_space_write_multi_stream_8 "space" "handle" "offset" "datap" "count"
-.It Fn bus_space_write_region_stream_1 "space" "handle" "offset" "datap" "count"
-.It Fn bus_space_write_region_stream_2 "space" "handle" "offset" "datap" "count"
-.It Fn bus_space_write_region_stream_4 "space" "handle" "offset" "datap" "count"
-.It Fn bus_space_write_region_stream_8 "space" "handle" "offset" "datap" "count"
+.It Fn bus_space_write_multi_stream_1 "space" "handle" "offset" "addr" "count"
+.It Fn bus_space_write_multi_stream_2 "space" "handle" "offset" "addr" "count"
+.It Fn bus_space_write_multi_stream_4 "space" "handle" "offset" "addr" "count"
+.It Fn bus_space_write_multi_stream_8 "space" "handle" "offset" "addr" "count"
+.It Fn bus_space_write_region_stream_1 "space" "handle" "offset" "addr" "count"
+.It Fn bus_space_write_region_stream_2 "space" "handle" "offset" "addr" "count"
+.It Fn bus_space_write_region_stream_4 "space" "handle" "offset" "addr" "count"
+.It Fn bus_space_write_region_stream_8 "space" "handle" "offset" "addr" "count"
 .El
 .Pp
 These functions are defined just as their non-stream counterparts,
@@ -1586,5 +1564,8 @@
 Jason Thorpe, and Charles Hannum, but the rest of the
 .Nx
 developers and the user community played a significant role in development.
+.Pp
+(Credits for the FreeBSD VERSION NEEDED). 
 .Pp
-Chris Demetriou wrote this manual page.
+This manual page was written by Chris Demetriou for the NetBSD Project.
+Hiten Pandya made necessary modifications for the FreeBSD Project.
